资讯专栏INFORMATION COLUMN

[Leetcode] Dungeon Game 地牢游戏

taoszu / 2075人阅读

摘要:动态规划复杂度时间空间递归栈思路骑士向右或者向下走,如果血量小于就死掉了,这会使得计算变得很复杂。假设表示点和的血量,表示走到和要扣除的血量。最右下角那个节点没有待逆推的节点,所以我们假设其逆推节点的血量为。

Dungeon Game

The demons had captured the princess (P) and imprisoned her in the bottom-right corner of a dungeon. The dungeon consists of M x N rooms laid out in a 2D grid. Our valiant knight (K) was initially positioned in the top-left room and must fight his way through the dungeon to rescue the princess.

The knight has an initial health point represented by a positive integer. If at any point his health point drops to 0 or below, he dies immediately.

Some of the rooms are guarded by demons, so the knight loses health (negative integers) upon entering these rooms; other rooms are either empty (0"s) or contain magic orbs that increase the knight"s health (positive integers).

In order to reach the princess as quickly as possible, the knight decides to move only rightward or downward in each step.

Write a function to determine the knight"s minimum initial health so that he is able to rescue the princess.

For example, given the dungeon below, the initial health of the knight must be at least 7 if he follows the optimal path RIGHT-> RIGHT -> DOWN -> DOWN.

-2 (K)    -3         3
-5        -10        1
10         30       -5 (P)

Notes:

The knight"s health has no upper bound. Any room can contain threats or power-ups, even the first room the knight enters and the bottom-right room where the princess is imprisoned.

动态规划 复杂度

时间 O(N) 空间 O(N) 递归栈

思路

骑士向右或者向下走,如果血量小于0就死掉了,这会使得计算变得很复杂。如果我们从后往前看,从最后一个格子逆推回去,就会简单很多。每个格子可以是它下方或者右方的格子逆推回来,那么要让其实的血量最少,我们则要保证逆推的每一步都处于活着的状态,且选择活着的状态中,血量较小的那一种。假设health[i][j]表示点i和j的血量,dungeon[i][j]表示走到i和j要扣除的血量。如果从下方逆推回上面,则血量为health[i][j] = health[i + 1][j] - dungeon[i][j],但要考虑,如果该格子如果扣血扣太多的,则这样相减血量会成为负数,说明骑士就已经死了,这样的话我们要保证扣完血后骑士还活着,则该点的血量就应该为1。所以其实是health[i][j] = Math.max(health[i + 1][j] - dungeon[i][j], 1)。同理,如果从右边逆推回来,则health[i][j] = Math.max(health[i][j] - dungeon[i][j + 1], 1)。最后,我们在这两个逆推的值中,取较小的那个就行了。

注意

由于最下面一行和最右面一列比较特殊,只有一种逆推方法,所以我们要先多带带处理一下。

最右下角那个节点没有待逆推的节点,所以我们假设其逆推节点的血量为1。

代码
public class Solution {
    public int calculateMinimumHP(int[][] dungeon) {
        if(dungeon == null || dungeon.length == 0) return 1;
        int m = dungeon.length;
        int n = dungeon[0].length;
        int[][] health = new int[m][n];
        health[m - 1][n - 1] = Math.max(1 - dungeon[m - 1][n - 1], 1);
        // 逆推最后一列的血量
        for(int i = m - 2; i >= 0; i--){
            health[i][n - 1] = Math.max(health[i + 1][n - 1] - dungeon[i][n - 1], 1);
        }
        // 逆推最后一行的血量
        for(int j = n - 2; j >= 0; j--){
            health[m - 1][j] = Math.max(health[m - 1][j + 1] - dungeon[m - 1][j], 1);
        }
        // 对于每个节点,从其下方和右方逆推回来
        for(int i = m - 2; i >= 0; i--){
            for(int j = n - 2; j >= 0; j--){
                int down = Math.max(health[i + 1][j] - dungeon[i][j], 1);
                int right = Math.max(health[i][j + 1] - dungeon[i][j], 1);
                health[i][j] = Math.min(down, right);
            }
        }
        return health[0][0];
    }
}

文章版权归作者所有,未经允许请勿转载,若此文章存在违规行为,您可以联系管理员删除。

转载请注明本文地址:https://www.ucloud.cn/yun/64684.html

相关文章

  • [leetcode]174. Dungeon Game

    摘要:为了保证骑士可以最终到达,我们可以从终点逆向走到起点。为正数表示是药水,骑士可以相应降低初始血量。为负数表明要增加血量来保证存活。用二维空间来表示当前位置所需的最小血量,不断向左上方走直到起点。用来表示当前层与下一层。 The demons had captured the princess (P) and imprisoned her in the bottom-right cor...

    siberiawolf 评论0 收藏0
  • 174. Dungeon Game

    摘要:题目解答这一题最重要的是把所剩血量初始化血量走这一步消耗的血量这句话读懂。那么我们假设是走完后所剩余的血量肯定是大于等于的。如果想存活下来,最少需要上一步血量,即上一步血量然后分类讨论上一步血量的可能性,注意边界情况的初始化即可。 题目: The demons had captured the princess (P) and imprisoned her in the bottom-...

    wanglu1209 评论0 收藏0
  • [Leetcode] Nim Game 尼姆游戏

    摘要:脑筋急转弯复杂度时间空间思路这题往小说可以追溯到小学奥数或者脑筋急转弯的书中,往大说可以深究到博弈论。代码如果一开始就是的倍数,你就输了,因为对方可以用同样的策略 Nim Game You are playing the following Nim Game with your friend: There is a heap of stones on the table, each ...

    cartoon 评论0 收藏0
  • [Leetcode] Jump Game 跳跃游戏

    摘要:代码记录下当前区域的上界,以便待会更新下一个区域的上界更新下一个区域的上界更新下一个区域的下界后续如果要求返回最短跳跃路径,如何实现可以使用,并根据一个全局最短步数维护一个全局最短路径,当搜索完所有可能后返回这个全局最短路径。 Jump Game I 最新解法请见:https://yanjia.me/zh/2019/01/... Given an array of non-negat...

    venmos 评论0 收藏0
  • [Leetcode] Game of Life 生命游戏

    摘要:思路普通解法,遍历每一个细胞求值,用一个的矩阵存放结果。求值过程,稍微分析一下可知,其实就是按照以下的矩阵进行结果是可数的。 According to the Wikipedias article: The Game of Life, also knownsimply as Life, is a cellular automaton devised by the Britishmath...

    android_c 评论0 收藏0

发表评论

0条评论

最新活动
阅读需要支付1元查看
<